/*
 * Copyright (c) 2010 Nokia Corporation and/or its subsidiary(-ies).
 *
 * This file is part of Qt Web Runtime.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 */

var __s60_start_and_wait_cb;

//callback function
function __s60_on_app_exit(){
  if (__s60_start_and_wait_cb != null){
    __s60_start_and_wait_cb();
  }
  window.widget.onshow = null;
}

function __s60_on_app_start(){
  window.widget.onhide = null;
  window.widget.onshow = __s60_on_app_exit;
}

/*
 *This function launches the camera apllication
 *@param id : id of the application to be opened.
 *@param args : argument to be passed.
 *@param app_exit_cb : callback to be called when exit happpens.
 */

function __s60_start_and_wait(app_exit_cb){
  __s60_start_and_wait_cb = app_exit_cb;
  window.widget.onhide = __s60_on_app_start;
 // window.widget.openApplication(id, args);
}

var takePicscb = null;

var takePicecb = null;

var CameraPlugin = null;

var __jilRecordCompleteCallback = null;
var  __RecordCompleteECB = null;

function callbackfunc(result){

                var error = CameraPlugin.errorCode;

                if (error == 0) {

                     takePicscb(result);
                }
                else {
                    takePicecb(error);
                }
            }

function recordCompleteCallback(rv)
{
    window.widget.onhide = null;
    __recordingInProgress = false;

    var error = CameraPlugin.errorCode;

    if (__jilRecordCompleteCallback && error == 0) {
        __jilRecordCompleteCallback(rv);
    }
    else {
        __RecordCompleteECB(error);
    }
}



if ((typeof wrt.device.camera) == 'undefined') {
/**
 * A wrapper JS class for objects implementing ICamera interface of Camera Plugin
 *
 * @namespace
 */
    wrt.device.camera = (function(){

    var DeviceException = wrt.device.DeviceException;
    var DeviceAPIError = wrt.device.DeviceAPIError;
    //camera application UID.
    var CAMERA_APP_ID = 0x101f857a;
    var error = new DeviceException(0,'dummy');
    var errorAPI = new DeviceAPIError(0,'dummy');

    //flag indicating whether startRecording has been called
    var __recordingInProgress = false;

    /*
     * Internal
     * qt contacts interface object.
     */
     function camera_cb(errorCode,transId,result)
    {
        
        var retObj = asyncCallbackMap.get(transId);
        asyncCallbackMap.remove(transId);
		//Temporary hack for properly work of callback
		//One instantion of camera has been supported
		asyncCallbackMap.usec_count = 0;
        if(retObj)
        {
            var callback = retObj.success_cb;
            var errorCallback = retObj.error_cb;
            if(errorCode)
            {
                 if (errorCallback) {
                    errorCallback(new DeviceException(errorCode, "Camera : startCamera : error occured."));
                }
            }
            else
            {
                
                callback(result);
                
            }
        }
        
    }
        var psCameraIntf = wrt._services.load("wrt.device.camera", "com.nokia.ICamera", "1.0");	
				psCameraIntf.addEventListener("asyncCallback(int, int, QVariant)",camera_cb);
        	   


    /*
                  * supportedsizes global variable
                  */
                 var qtCameraSupportedSizes = [];
                 try{
                 qtCameraSupportedSizes = psCameraIntf.supportedSizes();//supported sizes
                }
                catch(er){
                    sfw_debug("Unable to get supported sizes"+er);
                }
                 /*
                 * Read only property - supported sizes
                 */
                 psCameraIntf.supportedSizes = qtCameraSupportedSizes;

            function af(str){

            }
            /*
             * golbal variable to keep track of the domObject
             */
            var prevDomObj = null;

            var pluginObj = null;

            var vferrcode = 0;
            var vferrmessage = "Success";

            var width = 0;
            var height = 0;
            function getLastIndexOf(htmlPath, str){
            var buffer = htmlPath;
            var index = 0;
            var prevIndex = 0;
            while ((index = buffer.indexOf(str)) != -1) {
                //alert("index"+index);
                buffer = buffer.slice((index + 1));
                prevIndex = prevIndex + index + 1;
                //alert("prevIndex"+prevIndex);
            }
            return prevIndex;
        }


        // When widget gets hidden while video capture in progress this function gets invoked. Here we stop the video Capturing.
    // Issue - If an error occurs while stopping we dont have a way to communicate to the user in this scenario
            function widgetHidden(){
                try{
                    if (CameraPlugin != null && __recordingInProgress){
                            var returnObject = CameraPlugin.StopRecording();
                            __recordingInProgress = false;
                    }
                    window.widget.onhide = null;
                }
                catch(e){
                    af("exception in widgethidden func"+e.toString());
                }
            }
  return {
            /**
            * @constant {String}
            * interfaceName.
            */
            interfaceName: "camera",
            version: wrt.device._interfaceVersion,
         /*
                 * Read only property - supported sizes
                 */

                supportedSizes :  qtCameraSupportedSizes,

     /**
     *
     * This API starts the camera application, showing the camera user interface.<br>
     * This is an asynchronous one-time notification API and hence is not associated with a transaction id.<br>
     * The camera application remains open even after the user takes pictures.<br>
     * The application can be closed by the user who manually exits the camera application.<br>
     * <br>
     * <ul>The state operation of the Camera API is as follows:<br>
     *        1.  The consumer application invokes startCamera by supplying the callback function.
     *          This launches the camera application showing the camera user interface.<br>
     *        2.  The user is given full control of the application and once a picture is taken,
     *        the captured image needs to be saved by specifying the path and filename.<br>
     *        3.  The user may manually exit the camera upon which the callback registered in
     *        startCamera, is invoked. This returns an array of picture data.<br></ul>
     * @param {function} successCB The supplied function gets invoked asynchronously after the user exits the camera application.<br>
     *        In order to handle multiple pictures in a single callback, the callback picture parameter is specified as an array.
     *        Signature:
     *            <b>successCB({@link data}</b></i>). data : Array of data that matches the picture schema.
     *
     * @param {function} [errorCB(DeviceError)] This callback function gets invoked with
     * {@link DeviceError} object when error occurs in processing the async request.
     *
     * @return {number} A unique transactionID will be returned. Currently only one instantiation of camera is supported and camera application to be closed by user.

     * @throws {DeviceException} Code 1 (MISSING_ARG_ERR): A mandatory argument in a method is missing. <ul><li>successCallback is undefined.</li></ul>
     *                           Code 2 (INVALID_ARG_ERR): An argument passed is not an expected type and is invalid.<ul><li>successCallback is not a function</li>
     *                                                        <li>errorCallback is not a function</li>
     *                                                        </ul>
     */

                startCamera:function(sCB, eCB){


                var start_date = new Date();

                if (sCB == undefined || sCB == null){
                    throw new DeviceException(error.MISSING_ARG_ERR, 'startCamera:Missing Success Callback');
                }

        if (sCB && ((typeof sCB) != "function" )){
                throw new DeviceException(error.INVALID_ARG_ERR, 'startCamera:Invalid Success Callback');
        }

                if (eCB && ((typeof eCB) != "function" )){
                throw new DeviceException(error.INVALID_ARG_ERR, 'startCamera:Invalid Error Callback');
        }

          try{
				var tid = asyncCallbackMap.add(sCB, eCB);
				    var errormap = psCameraIntf.startCamera(tid);
                }catch(er){
                    sfw_debug("Unable to launch Camera"+er);
                }
		if (navigator.appVersion.toLowerCase().indexOf("linux") == -1) 
        {
                if ( errormap.ErrorCode != 0) {
                        if ((eCB != null) && (eCB != undefined))
                            eCB(new DeviceAPIError(errormap.ErrorCode, "Camera:startCamera:Operation Failed"));
                        }
                else{
                 __s60_start_and_wait(callback);
                }
		}	

                //callback function.
                function callback(arg1, arg2, arg3){
                    var end_date = new Date();
                    //get the list of images taken between the start and exit of the camera.
                    try{
                    var result = psCameraIntf.getList(start_date, end_date);
                  }
                  catch(er){
                  sfw_debug("Unable to get meta data list of images"+er);
                  }
                    var errormap = result.errormap;
                    if ( errormap.ErrorCode != 0) {
                        eCB(new DeviceAPIError(errormap.ErrorCode, "Camera:Getlist:Operation Failed"));
                        }
                    else {
                        sCB(result.picturedata);
                        }
                    }
                },
     /**
     *
     * This method stops the camera which was started in viewfinder mode using startViewFinder.
     * This is a synchronous method.
     *
     *
     * @return {void}  The camera preview output is stopped.
     *
     */
            stopViewFinder: function(){
            try {
                    // If the plugin object gets deleted in the callback widget crashes. To fix this crash we have made removal of plugin after a delay of 0.5 seconds
                // This is actually a bug in webkit which needs to be fixed.
                if (prevDomObj) {
                    CameraPlugin.StopViewFinder();
                    setTimeout(function(){
                                prevDomObj.removeChild(pluginObj);
                     prevDomObj = null;
                     cameraPlugin = null;
                                    },500);

                }
            }
            catch (e) {
                af("Exception in stop in cjse" + e.toString());
                throw e;
            }
        },
     /**
     *
     * It is used to launch camera in viewfinder mode and the camera output is shown in the preview window provided by user.
     * This api needs to be invoked by the user before calling any other apis.This is a synchronous method.
     *
     *
     * @param {DomObject} prevWindow Specifies the preview window where the camera output will be rendered on the widget..
     * @param {function} [successCB] Called when view finder start up.
     * @param {function} [errorCB(DeviceError)] This callback function gets invoked with
     * {@link DeviceError} object when error occurs in processing the async request.<br>
     * <br>
     * <b>Status Codes</b> are the codes returned in errorCallback function.<br><br>
     *
     *                 Code 103 (SERVICE_BUSY_ERR): If the window is already set or if the startViewFinder is called for the 2nd time, without calling stopViewFinder.<br>
     *                           Code 104 (SERVICE_IN_USE_ERR):When the camera is been accessed by other applications or native camera is running.
     *
     * @return {void } Camera will be launched and output is displayed in the preview window prvided by the user.

     * @throws {DeviceException} Code 1 (MISSING_ARG_ERR): A mandatory argument in a method is missing. <ul><li>The height and width of the domObject is mandatory.</li></ul>
     *                           Code 2 (INVALID_ARG_ERR): An argument passed is not an expected type and is invalid.<ul>
     *                                                        <li>And when the height or width of the window passed is invalid.</li></ul>
     *
     *
     */
                startViewFinder: function (__domObject){
                try{
                    if (!__domObject){
                        throw new DeviceException(error.MISSING_ARG_ERR,'domObject input is missing');
                    }
                    if (typeof __domObject != 'object'){
                        throw new DeviceException(error.INVALID_ARG_ERR,'domObject input is not an object');
                    }
                    if (!__domObject.style){
                        throw new DeviceException(error.INVALID_ARG_ERR,'domObject input does not mention the height and width of the window');
                    }
                    if (prevDomObj){
                        throw new DeviceException(error.INVALID_ARG_ERR,'a window is already set. Cannot set another window');
                    }
                    width = __domObject.style.width ;
                    height = __domObject.style.height;
                    // if height and width are set through css .style.width and style.height are not having the set values.
                    // but clientWidth and clientHeight are containing the valid values. So in such cases we are trying to read
                    // from clientWidth and clientHeight

                    if (!__domObject.style.width)
                     {
                        width = __domObject.clientWidth;
                     }
                    if (!__domObject.style.height)
                     {
                        height = __domObject.clientHeight;
                     }

                    //TODO: need to check the lower limit and upper limit throw exception accordingly
                    if (width == "0px" || height == "0px"){
                        throw new DeviceException(error.INVALID_ARG_ERR,'domObject input is not valid.');
                    }
                    if (width == "" || height == ""){
                        throw new DeviceException(error.INVALID_ARG_ERR,'domObject input is not valid.');
                    }
                    var newdiv = document.createElement('div');
                    newdiv.id = "Camera";
                    newdiv.innerHTML = "\<object id = \"CameraDiv\" TYPE=nokiaplugin\/camera WIDTH="+width+" HEIGHT="+height+" text = \"Camera Nokia Plugin\" hidden="+true+"\>\<\/object\>";
                    __domObject.appendChild(newdiv, document.body.firstChild);
                    CameraPlugin = document.getElementById("CameraDiv");

                    pluginObj = newdiv;

                        if (CameraPlugin != null){
                            var w_width = parseInt(width) ;
                            var w_height = parseInt(height);
                            CameraPlugin.SetSize(w_width,w_height);
                            CameraPlugin.StartViewFinder();
                            var errcode = CameraPlugin.errorCode;
                            var errMessage = CameraPlugin.errorMessage;
                                if (errcode != 0){
                                    __domObject.removeChild(pluginObj);
                                    __domObject = null;
                                    throw new DeviceException(errcode, errMessage);
                                }
                                else{
                                        prevDomObj = __domObject;
                                }
                            }
                            else{
                                //todo the plugin is created which needs to be removed as error occured
                                throw new DeviceException(error.INVALID_ARG_ERR, 'Operation Failed');
                            }
                }
                catch(e){
                    af("exception in cjse setCamWindow()"+e.toString());
                    throw e;
                }
            },
     /**
     *  This method is used to capture a still image from the native camera whose output is seen at the window set by startViewFinder() method.
     *  This is an asynchronous method.
     *
     *
     * @param {Function}
     *         successCB  - The function which is called on success of CaptureImage.<br>
     *         Signature:
     *         <b>successCB({@link fileUri}</b></i>). fileUri : The file path where the captured image is stored is returned as argument to this function.
     * @param {imageOptions}
     *         [options] - Object is to specify the details of image capturing options, like the fileUri where the captured image has to be stored and a flag to specify if the lowest resolution of camera is to be used.
     * @param {function} [errorCB(DeviceError)] This callback function gets invoked with
     * {@link DeviceError} object when error occurs in processing the async request.
     * <br><br>
     * <b>Status Codes</b> are the codes returned in errorCallback function.<br>
     *
     *             Code 111 (NO_MEMORY_ERR):When device memory is exhausted.<br>
     *                       Code 106 (NOT_ALLOWED_ERR):This exception is thrown when user calls CaptureImage() API before calling startViewFinder(), or after failure of startViewFinder().<br>
     *             Code 108 (INVALID_URI_ERR):The file uri format is invalid.<br>
         Code 109 (URI_NOT_FOUND_ERR): The filePath input is not found.<br>
     * @return {string} File path to which the image will be saved is returned.
     * @exception {DeviceException} Code 1 (MISSING_ARG_ERR): Thrown when a mandatory input is missing.<br>
     *                              Code 2 (INVALID_ARG_ERR): An argument passed is not an expected type and is invalid.
     *                                                        <ul><li>When file having type(or extension) other than jpeg(jpg), this exception is thrown</li></ul>
     *
     */

            captureImage: function(__callback, __options, __errorCallback){
            try {
                var __flName = __options.fileUri;
                var __lowRes = __options.lowResolution;
                if (prevDomObj == null){
           if (__errorCallback) {
              setTimeout(function(){
                  __errorCallback(new DeviceException(error.NOT_ALLOWED_ERR, 'window is not set'));
              }, 1000);
              return;
             }
            else {
                throw new DeviceException(error.NOT_ALLOWED_ERR, 'window is not set');
            }
                }
                af("in cjse flname"+__flName);
                function validateFlName(fName){
                    var index = fName.indexOf(".");
                    if (index != -1){
                        var remName = fName.slice(index);
                        if (remName == ".jpg")
                            return true;
                        else
                            validateFlName(remName);
                    }
                    else
                        return false;
                };
                if (!__callback) {
                    throw new DeviceException(error.MISSING_ARG_ERR, 'success callback is mandatory');
                }
                if (typeof __callback != 'function') {
                    throw new DeviceException(error.INVALID_ARG_ERR, 'Invalid type of success callback');
                }
                if (__errorCallback) {
                    if (typeof __errorCallback != 'function') {
                        throw new DeviceException(error.INVALID_ARG_ERR, 'Invalid type of error callback');
                    }
                }
                takePicscb = __callback;
                takePicecb = __errorCallback;
                if (__flName) {
                    if (typeof __flName != 'string') {
                        throw new DeviceException(error.INVALID_ARG_ERR, 'Invalid type of file name input');
                    }
                }
                if (__lowRes) {
                    if (__lowRes != true && __lowRes != false) {
                        throw new DeviceException(error.INVALID_ARG_ERR, 'invalid type of lowRes input');
                    }
                }
                if (__flName != null && (__flName.length > 255 || __flName.length < 0)){
                    throw new DeviceException(error.INVALID_ARG_ERR, 'invalid size of file name');
                }
                // just only name of file given
                if (__flName != null && -1 == __flName.indexOf("/")) {
                        var htmlPath = location.pathname;
                        //This function is used as the lastIndexOf() of javascript was not working
                        var index = getLastIndexOf(htmlPath, "/");
                        var filePath = htmlPath.slice(0, (index));
                        __flName = "file:/" + filePath + __flName;
                    }
                if (__flName)
                    __flName = __flName + String.fromCharCode(0);
                if (prevDomObj == null){
                    throw new DeviceException(error.INVALID_ARG_ERR, 'window is not set');
                }
                else{
                    CameraPlugin.TakePicture("callbackfunc" + String.fromCharCode(0), __flName, __lowRes);
                    var errcode = CameraPlugin.errorCode;
                    var errMessage = CameraPlugin.errorMessage;
                    if (errcode != 0) {
                        switch (errcode) {
                            case error.INVALID_ARG_ERR:
                            case error.MISSING_ARG_ERR:
                            case error.NOT_SUPPORTED_ERR:
                                throw new DeviceException(errcode, errMessage);
                            default:
                                if (__errorCallback) {
                                    setTimeout(function(){
                                        __errorCallback(new DeviceException(errcode, errMessage));
                                    }, 1000);
                                    return;
                                }
                                else {
                                    throw new DeviceException(errcode, errMessage);
                                }
                            }
                         }
                     var retFlName = CameraPlugin.fileName;

                     return retFlName;
                }

            }
            catch (e) {
                af("Exception in captureImage in cjse" + e.toString());
                throw new DeviceException( e.code, e.message);
            }
        },



     /**
     * This method is used to start video capture.
     *
     * This is an asynchronous method.
     * @param {Function}
     *         successCB - The function which is called on success of startVideoCapture.
     *          Signature:
     *         <b>successCB({@link String}</b></i>). String : The file path where the video is stored is returned in this function after
     *         the videoCapture operation is completed by calling stopVideoCapture () or the max duration specified is reached.
     *
     * @param {videoOptions}
     *         [options] - Object to specify the details of video capturing options, like the fileUri where the captured video has to
     *         be stored and a flag to specify if the lowest resolution of camera is to be used. And the maximum duration upto which recording
     *         should happen if the user does not stop it in between using the stopVideoCapture API.
     *
     * @param {function} [errorCB(DeviceError)] This callback function gets invoked with
     * {@link DeviceError} object when error occurs in processing the async request.
     * <br><br>
     * <b>Status Codes</b> are the codes returned in errorCallback function.<br><br>
     *
     *             Code 111 (NO_MEMORY_ERR):When device memory is exhausted.<br>
     *             Code 106 (NOT_ALLOWED_ERR):This exception is thrown when user calls startVideoCapture () API before calling startViewFinder (), or after failure of startViewFinder ().<br>
     *             If user specifies lowResolution for mime type which does not support low resolution.<br>
     *             Code 105 (DATA_OUT_OF_RANGE_ERR): if the value passed for durInSecs is greater than default maximum value.<br>
     *             Code 108 (INVALID_URI_ERR): The file uri format is invalid.<br>
     *             Code 109 (URI_NOT_FOUND_ERR): The filePath input is not found.<br><ul><li>For eg. If user specifies file:///c:/data/MyImages/a.jpg and MyImages folder is not found then this exception will be thrown.</li></ul>
     * @return {string} File path to which the image will be saved is returned.
     * @exception {DeviceException} Code 1 (MISSING_ARG_ERR): Thrown when a mandatory input is missing.<br>
     *                              Code 2 (INVALID_ARG_ERR): An argument passed is not an expected type and is invalid. <ul><li>When file having type(or extension) other than .mp4 or .3gp or.3g2, this exception is thrown. Or if user passes invalid type.</li></ul>
     *
     */

            startVideoCapture: function(__callback, __options, __errorCallback) {
                try {
                var __fileName = __options.fileUri;
                var __lowResolutionFlag = __options.lowResolution;
                var __maxDuration = __options.duration;

          if (prevDomObj == null){
           if (__errorCallback) {
              setTimeout(function(){
                  __errorCallback(new DeviceException(error.NOT_ALLOWED_ERR, 'window is not set'));
              }, 1000);
              return;
             }
            else {
                throw new DeviceException(error.NOT_ALLOWED_ERR, 'window is not set');
            }
                }
                if (__callback == null || typeof __callback == undefined) {
                    throw new DeviceException(error.MISSING_ARG_ERR,'callback is missing');
                }

                else if ( typeof __callback != "function") {
                    throw new DeviceException(error.INVALID_ARG_ERR,'callback is not a function');
                }

                if (__errorCallback != null && typeof __errorCallback != undefined) {
                    if ( typeof __errorCallback != "function") {
                        throw new DeviceException(error.INVALID_ARG_ERR,'error callback is not a function');
                    }

                }

                if (__fileName != null && typeof __fileName != "undefined" && __fileName != "") {
                    if ((typeof __fileName != "string") ||(__fileName.length > 255 || __fileName.length < 0)) {
                        throw new DeviceException(error.INVALID_ARG_ERR, 'filename is not a string');
                    }
                }
        if (!__fileName)
          __fileName = null;

                if (__lowResolutionFlag != null && typeof __lowResolutionFlag != "undefined" ) {
                    if (typeof __lowResolutionFlag != "boolean") {
                        throw new DeviceException(error.INVALID_ARG_ERR, 'low Resolution is not a boolean value');
                    }
                }

                else
                   __lowResolutionFlag = false;

                if (__maxDuration != null && typeof __maxDuration != "undefined") {
                    if (typeof __maxDuration != "number" || (__maxDuration != __maxDuration | 0)) {
                        throw new DeviceException(error.INVALID_ARG_ERR, 'maximum duration  is invalid');
                    }

                    else if (__maxDuration <= 0 || __maxDuration > 300) {
                       throw new DeviceException(error.DATA_OUT_OF_RANGE_ERR,'maximum duration is out of range ');
                    }

                }

                        else
                   __maxDuration = 300;


                    __jilRecordCompleteCallback = __callback;
                    __RecordCompleteECB = __errorCallback;
        if (__fileName != null && -1 == __fileName.indexOf("/")) {
            var htmlPath = location.pathname;
            //This function is used as the lastIndexOf() of javascript was not working
            var index = getLastIndexOf(htmlPath, "/");
            var filePath = htmlPath.slice(0, (index));
            __fileName = "file:/" + filePath + __fileName;
          }
                    if (__fileName!=null)
                       __fileName = __fileName +String.fromCharCode(0);

                    __recordingInProgress = true;
                    CameraPlugin.StartRecording( "recordCompleteCallback" + String.fromCharCode(0),__fileName, __lowResolutionFlag, __maxDuration, false );

                    //use only errorMessage, returnObject.errorMessage accessible only once
                    var errorMessage =  CameraPlugin.errorMessage;
                    var errCode = CameraPlugin.errorCode;
                    var retValue = CameraPlugin.fileName;
                    var tid = CameraPlugin.transactionId;

                    if (errCode != 0) {
                        __recordingInProgress = false;
                        switch (errCode) {
                            case error.INVALID_ARG_ERR:
                            case error.MISSING_ARG_ERR:
                            case error.NOT_SUPPORTED_ERR:
                                throw new DeviceException(errCode, errorMessage);
                            default:
                                if (__errorCallback) {
                                    setTimeout(function(){
                                        __errorCallback(new DeviceException(errCode, errorMessage));
                                    }, 1000);
                                    return;
                                }
                                else {
                                    throw new DeviceException(errCode, errorMessage);
                                }
                            }
                         }
                   window.widget.onhide = widgetHidden;
                   return   retValue;
                  }

                catch(e) {
                    if (e.code != 0) {
                        __recordingInProgress = false;
                        switch (e.code) {
                            case error.INVALID_ARG_ERR:
                            case error.MISSING_ARG_ERR:
                            case error.NOT_SUPPORTED_ERR:
                                throw new DeviceException(errCode, errorMessage);
                            default:
                                if (__errorCallback) {
                                    setTimeout(function(){
                                        __errorCallback(new DeviceException(e.code, e.message));
                                    }, 1000);
                                    return;
                                }
                                else {
                                    throw new DeviceException(e.code, e.message);
                                }
                            }
                         }
                }
            },


     /**
     *
     * This method stops Video Capture/recording operation.
     *
     * @return {void}  If Video Capture operation is inprogress it will be stopped.
     * @exception {DeviceException} Code 106 (NOT_ALLOWED_ERR): If the stopVideoCapture is called before window is set.<br>
     */

          stopVideoCapture : function (){
            try{
                    if (prevDomObj == null){
                        throw new DeviceException(error.NOT_ALLOWED_ERR, 'window is not set');
                    }
                    var returnObject = CameraPlugin.StopRecording(  );

                    var errorMessage = CameraPlugin.errorMessage;
                    var errCode = CameraPlugin.errorCode;

                    if (errCode != 0 && errCode != 104) {

                           throw new DeviceException(errCode, errorMessage);

                         }

                }
                catch(e) {

                    throw new DeviceException( e.code, e.message);
                }
          }
    }; //End return
    })();//End camera
}// end if
